
package edu.uwec.cs.wickmr.life.singleton;

import java.util.*;

public class Cell {
	protected int row;
	protected int col;
	protected CellState cellState;
	
	public Cell(int row, int col){
		// TODO: C6 - Modify constructor in the Cell class.
		// Instructions:
		//   1. Set "cellState" to the result of DeadState.create()
		this.row = row;
		this.col = col;
		this.cellState = null;
	}
	public void live(){
		cellState = cellState.live();
	}
	public void die(){
		cellState = cellState.die();
	}
	public boolean isAlive(){
		return cellState.isAlive();
	}
	public void toggle(){
		cellState = cellState.toggle();
	}
	public void addToLiveNeighbors(List liveNeighbors){
		cellState.addToLiveNeighbors(liveNeighbors);
	}
	// Count the number of live neighbors in the given game
	public int nbrOfNeighbors(GameOfLife game){
		int result;
		
		int n = 0;
		int x = 0;
		int y = row-1;
		List liveNeighbors = new LinkedList();
	
		if ( y < 0 ){ y = game.getRows()-1; }
		for (int rCt = 1; rCt <= 3; rCt++){
			x = col-1;
			if ( x < 0 ){ x = game.getCols()-1;}
			for(int cCt = 1; cCt <= 3; cCt++){
				if ( x != col || y != row ){
					game.cellAt(y,x).addToLiveNeighbors(liveNeighbors);
				}
				x = (x+1) % game.getCols();
			}
			y = (y+1)%game.getRows();
		}
		return liveNeighbors.size();

	}

}
