
package edu.uwec.cs.wickmr.life.state;

import java.util.List;
/*
 * 
 * Represents the abstract super class of all concrete states.
 */
public abstract class CellState {
	// Defines the live behavior of all states.	
	public abstract CellState live();
	
	// Defines the die behavior of all states.
	public abstract CellState die();
	
	// Defines the toggle behavior of the state.
	public abstract CellState toggle();
	
	// Defines the isAlive behavior of the state.
	public abstract boolean isAlive();
	
	// Adds this instance to the list of the instance is alive.
	public abstract void addToLiveNeighbors(List liveNeighbors);
	
}
