
package edu.uwec.cs.wickmr.life.template;

import java.util.List;
/*
 * 
 * This class represents the Alive state in the game of life.
 */
public class AliveState extends CellState {
	protected static AliveState instance = null;
	
	private AliveState(){
	}
	
	public static AliveState create(){
		if (instance == null){
			instance = new AliveState();
		}
		return instance;
	}
	// Defines the behavior of a live state dieing.
	public CellState die(){
		return DeadState.create();
	}
	// Defines the bahavior of a live state response to the isAlive question.
	public boolean isAlive(){
		return true;
	}
	// Defines the toggle behavior for a live state.
	public CellState toggle(){
		return die();
	}
	public void addToLiveNeighbors(List liveNeighbors){
		liveNeighbors.add(this);
	}
	public void accept(LifeVisitor visitor, Cell cell, GameOfLife game, List commands){
		visitor.visitLiveCell(cell, game, commands);
	}
}
