package edu.uwec.cs.wickmr.life.template;
import java.util.*;

public abstract class LifeVisitor {
	final public void visit(Cell cell, GameOfLife game, List commands){
		cell.accept(this, game, commands);
	}
	final public void visitLiveCell(Cell cell, GameOfLife game, List commands){
		int n = cell.nbrOfNeighbors(game);
		if ( shouldDie(n)){
			commands.add( new DieCommand(cell));
		}
	}
	final public void visitDeadCell(Cell cell, GameOfLife game, List commands){
		int n = cell.nbrOfNeighbors(game);
		if ( shouldLive(n) ){
			commands.add( new LiveCommand(cell));
		}
	}
	protected abstract boolean shouldLive(int nbrNeighbors);
	protected abstract boolean shouldDie(int nbrNeighbors);

}
