
package edu.uwec.cs.wickmr.life.visitor;

import java.util.List;
/*
 * 
 * This class represents the Alive state in the game of life.
 */
public class DeadState extends CellState {
	protected static DeadState instance = null;
	
	private DeadState(){
	}
	
	public static DeadState create(){
		if ( instance == null ){
			instance = new DeadState();
		}
		return instance;
	}
	//	Defines the behavior of a dead state coming to life.
	public CellState live(){
		return AliveState.create();
	}
	//	Defines the bahavior of a dead state response to the isAlive question.
	public boolean isAlive(){
		return false;
	}
	//	Defines the toggle behavior for a dead state.
	public CellState toggle(){
		return live();
	}
	
	public void addToLiveNeighbors(List liveNeighbors){
		// Don't add yourself as you are dead.
	}
	
	public void accept(LifeVisitor visitor, Cell cell, GameOfLife game, List commands){
		// TODO: E3 - Implement the accept(LifeVisitor, Cell, GameOfLife, Object) method in the DeadState class.
		//   1. Write a method call to the "vistDeadCell(Cell,GameOfLife,List)" of "visitor"
		//         passing it the given parameters.
	}
}
