package edu.uwec.cs.wickmr.life.visitor;

import java.util.List;

public class HighLifeVisitor extends LifeVisitor {
	public void visitLiveCell(Cell cell, GameOfLife game, List commands){
		int n = cell.nbrOfNeighbors(game);
		if ( n != 2 && n != 3){
			commands.add( new DieCommand(cell));
		}
	}
	public void visitDeadCell(Cell cell, GameOfLife game, List commands){
		int n = cell.nbrOfNeighbors(game);
		if ( n == 3 || n == 6 ){
			commands.add( new LiveCommand(cell));
		}
	}
}
