/*
 * Created on Jan 20, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.uwec.cs.wickmr.life.zfinished;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class GameOfLife  {
	protected int ROWS;
	protected int COLS;
	Cell grid[][];
	List observers;
	
	public GameOfLife(int rows, int cols){
		this.ROWS = rows;
		this.COLS = cols;
		this.grid = new Cell[ROWS][COLS];
		this.observers = new LinkedList();
		clearGrid(grid);
	}
	protected void clearGrid(Cell[][] g){
		for(int i =0; i < ROWS; i++){
			for(int j=0; j < COLS; j++){
				g[i][j] = new Cell(i,j);
			}
		}
	}
	public int getRows(){
		return ROWS;
	}
	public int getCols(){
		return COLS;
	}
	public Cell cellAt(int r, int c){
		return grid[r][c];
	}
	protected void toggle(int r, int c){
		grid[r][c].toggle();
		notifyObservers();
	}
	protected boolean isAlive(int r, int c){
		return (grid[r][c].isAlive());
	}
	public void advance(LifeVisitor rulesVisitor){
		java.util.List commands = new LinkedList();
		int n =0;
		for(int i = 0; i < ROWS; i++){
			for(int j = 0; j < COLS; j++){
				// Visit Cell
				rulesVisitor.visit(grid[i][j], this, commands);
			}
		}
		Iterator commandItr = commands.iterator();
		while ( commandItr.hasNext()){
			((LifeCommand)(commandItr.next())).execute();
		}		
		notifyObservers();
	}
	// Add the given GameOfLifeUI to the list of observers.
	public void attach(GameOfLifeUI userInterface){
		observers.add(userInterface);
	}
	
	// Remove the given GameOfLifeUI from the list of observers.
	public void detach(GameOfLifeUI userInterface){
		observers.remove(userInterface);
	}
	
	// Inform all observers to update.
	public void notifyObservers(){
		Iterator uiItr = observers.iterator();
		while (uiItr.hasNext()){
			((GameOfLifeUI)uiItr.next()).update();
		}
	}

}
